<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width,initial-scale=1">
    <title>index.js - Documentation</title>

    <script src="scripts/prettify/prettify.js"></script>
    <script src="scripts/prettify/lang-css.js"></script>
    <!--[if lt IE 9]>
      <script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
    <![endif]-->
    <link type="text/css" rel="stylesheet" href="https://code.ionicframework.com/ionicons/2.0.1/css/ionicons.min.css">
    <link type="text/css" rel="stylesheet" href="styles/prettify-tomorrow.css">
    <link type="text/css" rel="stylesheet" href="styles/jsdoc-default.css">
</head>
<body>

<input type="checkbox" id="nav-trigger" class="nav-trigger" />
<label for="nav-trigger" class="navicon-button x">
  <div class="navicon"></div>
</label>

<label for="nav-trigger" class="overlay"></label>

<nav>
    <li class="nav-link nav-home-link"><a href="index.html">Home</a></li><li class="nav-heading">Tutorials</li><li class="nav-item"><a href="tutorial-AccountMethods.html">Account Methods</a></li><li class="nav-item"><a href="tutorial-AddCustomProvider.html">Add Custom Provider</a></li><li class="nav-item"><a href="tutorial-AddWalletKeys.html">Add Wallet Keys</a></li><li class="nav-item"><a href="tutorial-AdminContracts.html">Admin contracts interfaces</a></li><li class="nav-item"><a href="tutorial-ChooseProviders.html">Choose Providers</a></li><li class="nav-item"><a href="tutorial-Conversions.html">Utils for conversions</a></li><li class="nav-item"><a href="tutorial-CreateWalletAccount.html">Create new wallet account</a></li><li class="nav-item"><a href="tutorial-EstimateGas.html">Estimate gas and costs</a></li><li class="nav-item"><a href="tutorial-HDwallet.html">Import keys from mnemonic</a></li><li class="nav-item"><a href="tutorial-OperationsContracts.html">Operations contracts interfaces</a></li><li class="nav-item"><a href="tutorial-Query.html">Query</a></li><li class="nav-item"><a href="tutorial-QuickStart.html">QuickStart</a></li><li class="nav-item"><a href="tutorial-USD.html">USD contract interface </a></li><li class="nav-item"><a href="tutorial-Withdrawals.html">Withdrawals</a></li><li class="nav-heading">Classes</li><li class="nav-heading"><span class="nav-item-type type-class">C</span><span class="nav-item-name"><a href="Accounts.html">Accounts</a></span></li><li class="nav-item"><span class="nav-item-type type-function">F</span><span class="nav-item-name"><a href="Accounts.html#.getAccounts">getAccounts</a></span></li><li class="nav-item"><span class="nav-item-type type-function">F</span><span class="nav-item-name"><a href="Accounts.html#.getBalance">getBalance</a></span></li><li class="nav-item"><span class="nav-item-type type-function">F</span><span class="nav-item-name"><a href="Accounts.html#.getBalances">getBalances</a></span></li><li class="nav-item"><span class="nav-item-type type-function">F</span><span class="nav-item-name"><a href="Accounts.html#.importFromSeed">importFromSeed</a></span></li><li class="nav-item"><span class="nav-item-type type-function">F</span><span class="nav-item-name"><a href="Accounts.html#.transfer">transfer</a></span></li><li class="nav-item"><span class="nav-item-type type-function">F</span><span class="nav-item-name"><a href="Accounts.html#.transferFrom">transferFrom</a></span></li><li class="nav-heading"><span class="nav-item-type type-class">C</span><span class="nav-item-name"><a href="Contract.html">Contract</a></span></li><li class="nav-heading"><span class="nav-item-type type-class">C</span><span class="nav-item-name"><a href="ContractsConfiguration.html">ContractsConfiguration</a></span></li><li class="nav-heading"><span class="nav-item-type type-class">C</span><span class="nav-item-name"><a href="pm.html">pm</a></span></li><li class="nav-heading"><span class="nav-item-type type-class">C</span><span class="nav-item-name"><a href="pm.contracts.html">contracts</a></span></li><li class="nav-heading"><span class="nav-item-type type-class">C</span><span class="nav-item-name"><a href="pm.provider.html">provider</a></span></li><li class="nav-heading"><span class="nav-item-type type-class">C</span><span class="nav-item-name"><a href="pm.providers.html">providers</a></span></li><li class="nav-heading"><span class="nav-item-type type-class">C</span><span class="nav-item-name"><a href="pm.utils.html">utils</a></span></li><li class="nav-item"><span class="nav-item-type type-function">F</span><span class="nav-item-name"><a href="pm.utils.html#.fromToken">fromToken</a></span></li><li class="nav-item"><span class="nav-item-type type-function">F</span><span class="nav-item-name"><a href="pm.utils.html#.isTransactionHash">isTransactionHash</a></span></li><li class="nav-item"><span class="nav-item-type type-function">F</span><span class="nav-item-name"><a href="pm.utils.html#.sha256">sha256</a></span></li><li class="nav-item"><span class="nav-item-type type-function">F</span><span class="nav-item-name"><a href="pm.utils.html#.toToken">toToken</a></span></li><li class="nav-heading"><span class="nav-item-type type-class">C</span><span class="nav-item-name"><a href="pm.wallet.html">wallet</a></span></li><li class="nav-heading"><span class="nav-item-type type-class">C</span><span class="nav-item-name"><a href="Provider.html">Provider</a></span></li><li class="nav-heading"><span class="nav-item-type type-class">C</span><span class="nav-item-name"><a href="ProviderConfiguration.html">ProviderConfiguration</a></span></li><li class="nav-heading"><span class="nav-item-type type-class">C</span><span class="nav-item-name"><a href="ProviderConfigurationFiles.html">ProviderConfigurationFiles</a></span></li><li class="nav-heading"><span class="nav-item-type type-class">C</span><span class="nav-item-name"><a href="PublicMint.html">PublicMint</a></span></li><li class="nav-item"><span class="nav-item-type type-function">F</span><span class="nav-item-name"><a href="PublicMint.html#.provider">provider</a></span></li><li class="nav-item"><span class="nav-item-type type-function">F</span><span class="nav-item-name"><a href="PublicMint.html#.providers">providers</a></span></li><li class="nav-item"><span class="nav-item-type type-function">F</span><span class="nav-item-name"><a href="PublicMint.html#.versions">versions</a></span></li><li class="nav-heading">Modules</li><li class="nav-heading"><span class="nav-item-type type-module">M</span><span class="nav-item-name"><a href="module-Contracts.html">Contracts</a></span></li><li class="nav-item"><span class="nav-item-type type-function">F</span><span class="nav-item-name"><a href="module-Contracts.html#~InvalidAbiException">InvalidAbiException</a></span></li><li class="nav-item"><span class="nav-item-type type-function">F</span><span class="nav-item-name"><a href="module-Contracts.html#~InvalidAddressException">InvalidAddressException</a></span></li><li class="nav-heading"><span class="nav-item-type type-module">M</span><span class="nav-item-name"><a href="module-Providers.html">Providers</a></span></li><li class="nav-item"><span class="nav-item-type type-function">F</span><span class="nav-item-name"><a href="module-Providers.html#~getProviderList">getProviderList</a></span></li><li class="nav-heading"><span class="nav-item-type type-module">M</span><span class="nav-item-name"><a href="pm.query.module_Query.html">Query</a></span></li><li class="nav-item"><span class="nav-item-type type-function">F</span><span class="nav-item-name"><a href="pm.query.module_Query.html#~getWithdrawalTxByContract">getWithdrawalTxByContract</a></span></li><li class="nav-item"><span class="nav-item-type type-function">F</span><span class="nav-item-name"><a href="pm.query.module_Query.html#~getWithdrawalTypeByContract">getWithdrawalTypeByContract</a></span></li><li class="nav-item"><span class="nav-item-type type-function">F</span><span class="nav-item-name"><a href="pm.query.module_Query.html#~InvalidArgumentException">InvalidArgumentException</a></span></li><li class="nav-item"><span class="nav-item-type type-function">F</span><span class="nav-item-name"><a href="pm.query.module_Query.html#~InvalidContractException">InvalidContractException</a></span></li><li class="nav-item"><span class="nav-item-type type-function">F</span><span class="nav-item-name"><a href="pm.query.module_Query.html#~TransactionException">TransactionException</a></span></li><li class="nav-heading"><span class="nav-item-type type-module">M</span><span class="nav-item-name"><a href="pm.utils.module_Conversions.html">Conversions</a></span></li><li class="nav-item"><span class="nav-item-type type-function">F</span><span class="nav-item-name"><a href="pm.utils.module_Conversions.html#~Conversions">Conversions</a></span></li><li class="nav-heading"><a href="global.html">Globals</a></li><li class="nav-item"><span class="nav-item-type type-function">F</span><span class="nav-item-name"><a href="global.html#_checkListener">_checkListener</a></span></li><li class="nav-item"><span class="nav-item-type type-function">F</span><span class="nav-item-name"><a href="global.html#_createTxObject">_createTxObject</a></span></li><li class="nav-item"><span class="nav-item-type type-function">F</span><span class="nav-item-name"><a href="global.html#_decodeEventABI">_decodeEventABI</a></span></li><li class="nav-item"><span class="nav-item-type type-function">F</span><span class="nav-item-name"><a href="global.html#_decodeMethodReturn">_decodeMethodReturn</a></span></li><li class="nav-item"><span class="nav-item-type type-function">F</span><span class="nav-item-name"><a href="global.html#_encodeEventABI">_encodeEventABI</a></span></li><li class="nav-item"><span class="nav-item-type type-function">F</span><span class="nav-item-name"><a href="global.html#_encodeMethodABI">_encodeMethodABI</a></span></li><li class="nav-item"><span class="nav-item-type type-function">F</span><span class="nav-item-name"><a href="global.html#_executeMethod">_executeMethod</a></span></li><li class="nav-item"><span class="nav-item-type type-function">F</span><span class="nav-item-name"><a href="global.html#_generateEventOptions">_generateEventOptions</a></span></li><li class="nav-item"><span class="nav-item-type type-function">F</span><span class="nav-item-name"><a href="global.html#_getCallback">_getCallback</a></span></li><li class="nav-item"><span class="nav-item-type type-function">F</span><span class="nav-item-name"><a href="global.html#_getOrSetDefaultOptions">_getOrSetDefaultOptions</a></span></li><li class="nav-item"><span class="nav-item-type type-function">F</span><span class="nav-item-name"><a href="global.html#_on">_on</a></span></li><li class="nav-item"><span class="nav-item-type type-function">F</span><span class="nav-item-name"><a href="global.html#_processExecuteArguments">_processExecuteArguments</a></span></li><li class="nav-item"><span class="nav-item-type type-function">F</span><span class="nav-item-name"><a href="global.html#clone">clone</a></span></li><li class="nav-item"><span class="nav-item-type type-function">F</span><span class="nav-item-name"><a href="global.html#deploy">deploy</a></span></li><li class="nav-item"><span class="nav-item-type type-function">F</span><span class="nav-item-name"><a href="global.html#getPastEvents">getPastEvents</a></span></li><li class="nav-item"><span class="nav-item-type type-function">F</span><span class="nav-item-name"><a href="global.html#InvalidProviderException">InvalidProviderException</a></span></li><li class="nav-item"><span class="nav-item-type type-function">F</span><span class="nav-item-name"><a href="global.html#once">once</a></span></li>
</nav>

<div id="main">
    
    <h1 class="page-title">index.js</h1>
    

    



    
    <section>
        <article>
            <pre class="prettyprint source linenums"><code>import 'core-js'

import Web3 from 'web3'

import accounts from './accounts'
import createContractsInterface from './contracts'

import {
   resolveProvider,
   getProviderList,
   loadProviderWeb3,
   Provider
} from './providers'

import {
   version
} from '../package.json'

import utils from './utils'
import query from './query'

/**
 * Provider exception
 * @param {string} message Error message
 */
function InvalidProviderException(message) {
   this.message = message
   this.name = 'InvalidProviderException'
}

class PublicMint {
   /**
    * PublicMint - javascript devKit
    * Adds new namespace inside web3 `web3.pm`
    * This module depends of web3 package readme more [here](https://web3js.readthedocs.io/en/v1.2.4/index.html)
    *
    * @constructor
    * @param { Number | String | Provider } [ provider = 1 | provider = 'mainNet' | provider = new Provider ] provider
    * @param { String } [ connectionType = 'ws' ] connectionType ('ws' || 'http' ) default setting is ws (events).
    * @param { Object } [ customWeb3Options = { defaultBlock: 'latest', transactionConfirmationBlocks: 1 } ] - Web3 options example: [web3 docs](https://web3js.readthedocs.io/en/v1.2.4/web3-eth.html#transactionconfirmationblocks)
    * @param { Object } [ customContractsOptions = {  } ] - Contract options example: [web3 docs](https://web3js.readthedocs.io/en/v1.2.4/web3-eth-contract.html#web3-eth-contract)
    *
    * @return { Object } Will return an object with the classes of all major sub module from web3, including PublicMint modules
    *
    * [QuickStart tutorial]{@tutorial QuickStart}
    * @example const web3 = new PublicMint();
    */
   constructor(provider = 2020, connectionType = 'ws', customWeb3Options = {}, customContractsOptions = {}) {
      const web3opts = {
         defaultBlock: 'latest',
         transactionConfirmationBlocks: 1,
         ...customWeb3Options
      }

      this.provider = provider instanceof Object ? provider : resolveProvider(provider)

      if (this.provider === undefined) {
         throw new InvalidProviderException(`Provider identifier ${provider} not found`)
      }

      this.loadedWeb3Provider = loadProviderWeb3(connectionType, this.provider)

      this.web3 = new Web3(this.loadedWeb3Provider, null, web3opts)

      const contracts = createContractsInterface(this.web3, this.provider.chainId, customContractsOptions)

      /**
       *  @namespace pm
       *  @property { Object } pm.contracts - Contracts instances
       *  @property { Array&lt;Object> } pm.providers - List of providers
       *  @property { Provider } pm.provider Provider in use
       *  @property { Accounts } pm.wallet - Module for manage accounts and related methods (sign, transfer, ...)
       *  @property { Utils } pm.utils - [Utils module ](Utils)
       *  @property { String }  pm.version - Module Version
       *  @property { Query } pm.query - Module with helper functions for query blockchain.
       */
      this.web3 = Object.defineProperty(this.web3, 'pm', {
         value: {
            /**
             *  Contracts instances
             * @memberof pm
             * @type { Object }
             * @namespace pm.contracts
             * @property { Object } contracts.USD - ERC20  contract instance for USD token
             * @property { Object } contracts.admin.USD - Multi Signature contract instance for USD
             */
            contracts,
            /**
             *  Contracts instances
             * @memberof pm
             * @type { Object }
             * @namespace pm.providers
             * @property { Function } providers.getProviderList  - Get list of providers
             */
            providers: getProviderList,
            /**
             *  Contracts instances
             * @memberof pm
             * @type { Provider }
             * @namespace pm.provider
             * @property { Function } provider - Instance provider
             */
            provider: this.provider,
            /**
             *  Module of wallet actions [more info](https://web3js.readthedocs.io/en/v1.2.0/web3-eth-accounts.html#wallet)
             * @memberof pm
             * @type { Object }
             * @namespace pm.wallet
             * @property { Function } wallet.add - Adds an account using a private key or account object to the wallet.
             * @property { Function } wallet.remove - Removes an account from the wallet.
             * @property { Function } wallet.load - Loads a wallet from local storage and decrypts it.
             * @property { Function } wallet.clear - Securely empties the wallet and removes all its accounts.
             * @property { Function } wallet.encrypt - Encrypts all wallet accounts to an array of encrypted keystore v3 objects.
             * @property { Function } wallet.decrypt - Decrypts keystore v3 objects.
             * @property { Function } wallet.save - Stores the wallet encrypted and as string in local storage.
             * @property { Function } wallet.load - Loads a wallet from local storage and decrypts it.
             * @property { Object } wallet.accounts - Actions for added accounts.
             * @property { Function } wallet.accounts.getBalance - Get balance of account  `accounts.getBalance('0x0')`.
             * @property { Function } wallet.accounts.getBalances - Get balance of account `accounts.getBalances`.
             * @property { Function } wallet.accounts.transfer - Transfer balance using first wallet account.
             * @property { Function } wallet.accounts.transferFrom - TransferFrom same as transfer but specifying index or address .
             */
            wallet: accounts(this.web3),
            /**
             *  Module of utils
             * @memberof pm
             * @type { Object }
             * @namespace utils
             */
            utils: utils(this.web3.utils),
            /**
             *  Version of module
             * @memberof pm
             * @type { String }
             */
            version,
            /**
             *  Version of module
             * @memberof pm
             * @type { Query }
             */
            query: query(this.web3)
         }
      })

      // Delete modules not compatible with client
      // TODO: needs revision later
      delete this.web3.eth.personal
      delete this.web3.eth.ens
      delete this.web3.bzz
      delete this.web3.shh

      return this.web3
   }

   /**
    * Provider constructor
    */
   static provider(...args) {
      return new Provider(...args)
   }

   /**
    * Get providers list
    */
   static providers() {
      return getProviderList();
   }

   /**
    * Modules versions
    */
   static versions() {
      return {
         Web3: Web3.version,
         PublicMint: version
      }
   }
}

// Expose utils
PublicMint.utils = {
   ...Web3.utils,
   ...utils(Web3.utils)
}

export default PublicMint
</code></pre>
        </article>
    </section>




</div>

<br class="clear">

<footer>
    Generated by <a href="https://github.com/jsdoc3/jsdoc">JSDoc 3.6.3</a> on Fri Feb 21 2020 12:09:02 GMT+0000 (Western European Standard Time) using the Minami theme.
</footer>

<script>prettyPrint();</script>
<script src="scripts/linenumber.js"></script>
</body>
</html>
